OBJ
  fsrw : "fsrw"
  ser : "cserial"

'CON
'  FIRST_PIN = 16

DAT
  handle0 long 0[11] ' Handle used for general file operations
  curr_handle long 0
  readdir_block long 0[8] 'attrib, size, fname

'****************************************************************
' Public API Methods
'****************************************************************
PUB handlesize
  return 44 + 512

PRI loadhandle(handle)
  'ser.dbprintf1(string("loadhandle: %8x\n"), handle)
  ifnot handle
    'ser.dbprintf0(string("**** loadhandle 0 ****\n"))
    return
  if curr_handle <> handle
    if curr_handle
      fsrw.savecontext(curr_handle)
    curr_handle := handle
    fsrw.loadcontext(curr_handle)

PUB hreaddir(handle) | retval, attrib, filesize, fname[4], ptr1, ptr2, val
  if handle == 0
    return
  loadhandle(@handle0)
    
  ptr2 := @readdir_block
  repeat
    retval := \fsrw.pread(ptr2, 32) ' Read a directory entry
    if retval < 0
      return
    ifnot byte[ptr2] ' Check for the end of the directory
      return
    attrib := byte[ptr2 + 11] ' Get the attribute byte
    if (byte[ptr2] <> $e5) and ((attrib & $08) == 0) ' Exit loop if a valid file or directory entry
      quit
      
  filesize := readdir_block[7] ' Get the file size
  attrib := %0010 | (((attrib&1)^1)<<2) | (((attrib&%10000)<>0)&%1001) ' Set the "dwrx" bits
  ptr1 := @fname
  ' Get up to eight file name characters
  repeat 8
    val := byte[ptr2++]
    if val =< 32 or val > 126
      quit
    byte[ptr1++] := val
  ' Check for an extension  
  ptr2 := @readdir_block[2]
  val := byte[ptr2]
  if val > 32 and val =< 128
    byte[ptr1++] := "."
    ' Get up to 3 extension characters
    repeat 3
      val := byte[ptr2++]
      if val =< 32 or val > 126
        quit
      byte[ptr1++] := val
  byte[ptr1] := 0 ' NULL terminate the file name string
  readdir_block[0] := attrib ' Put attribute bits in the first long
  readdir_block[1] := filesize ' Put the file size in the second long
  bytemove(@readdir_block[2], @fname, 13) ' Put the file name starting at the third long
  return @readdir_block 
  
'========================================================

PUB mount(basepin)
  curr_handle := @handle0
  result := \fsrw.mount(basepin)  

PUB hopen(handle, fname, mode)
  'ser.dbprintf3(string("open %08x %s %s\n"), handle, fname, mode)
  if mode == "d"
    loadhandle(@handle0)
  else
    ifnot handle
      return -30
    longfill(handle, 0, 10)
    long[handle][10] := handle + 44
    loadhandle(handle)
  result := \fsrw.popen(fname, mode)

PUB hclose(handle) | retval
  'ser.dbprintf1(string("close %08x\n"), handle)
  loadhandle(handle)
  ifnot \fsrw.pclose
    result := 1
  curr_handle := 0

' This routine writes a chunk to a file
PUB hwrite(handle, buffer, num)
  'ser.dbprintf3(string("write %08x %08x %d\n"), handle, buffer, num)
  loadhandle(handle)
  result := \fsrw.pwrite(buffer, num)

' This routine reads a chunk from a file
PUB hread(handle, buffer, num)
  'ser.dbprintf3(string("read %08x %08x %d\n"), handle, buffer, num)
  loadhandle(handle)
  result := \fsrw.pread(buffer, num)

PUB hopendir(path)
  loadhandle(@handle0)
  \fsrw.opendir
  return @handle0

PUB hnextfile(fbuf)
  loadhandle(@handle0)
  result := \fsrw.nextfile(fbuf)

PUB hget_filesize(handle)
  ifnot handle
    return
  loadhandle(handle)
  result := \fsrw.get_filesize

PUB hseek(handle, position)
  loadhandle(handle)
  result := \fsrw.seek(position)

PUB htell(handle)
  loadhandle(handle)
  result := \fsrw.tell

PUB hflush(handle)
  loadhandle(handle)
  result := \fsrw.pflush

'========================================================
PUB hclosedir(handle)

PUB chdir(path)

PUB format

PUB mkdir(fname)

PUB chmod(fname, modebits)

PUB rename(fname1, fname2)

'========================================================
PUB popen(fname, mode)
  result := \fsrw.popen(fname, mode)

PUB pclose
  result := \fsrw.pclose

PUB pwrite(buffer, num)
  result := \fsrw.pwrite(buffer, num)

PUB pread(handle, buffer, num)
  result := \fsrw.pread(buffer, num)

PUB opendir
  result := \fsrw.opendir

PUB nextfile(fbuf)
  result := \fsrw.nextfile(fbuf)

PUB closedir
  result := \fsrw.pclose

PUB get_filesize
  result := \fsrw.get_filesize

PUB seek(handle, position)
  result := \fsrw.seek(position)

PUB tell
  result := \fsrw.tell

PUB pflush(handle)
  result := \fsrw.pflush
